package robo_d;

import java.text.DecimalFormat;

/**
 * Definicia bodu
 * @author kurilluk
 */

public class Point implements Comparable<Point> {

    /** lokalna pozicia bodu */
    private XYZ localPosition = null;

    /** globalna pozicia bodu */
    private XYZ globalPosition = new XYZ();

    public boolean koren = false;
    
    public boolean kmen = false;

    public boolean vyrobeny = false;

    public int index = -1;

    public int entita = -1;

   //static private  DecimalFormat df = new DecimalFormat("#.#");

 //=KONSTRUCTOR=================================================================

    public Point(){
        this (0,0,0);
    }

    /** konstruktor bodu */
    public Point(float x,float y, float z){
        this.globalPosition.Set(x, y, z);
        //this.localPosition = this.globalPosition;
    }

     public Point(XYZ pos){
         if(pos == null){
             this.globalPosition.Set(0,0,0);
             System.out.println("ERR: NULL POINT IN SECTOR !");
         }else{
        this.globalPosition.Set(pos.x, pos.y, pos.z);
         }
       //this.localPosition = this.globalPosition;
    }


    //=INSTANS=METOD============================================================

     /** Pozicia bodu */
    public XYZ Position(){
        return globalPosition;
    }

    public XYZ PositionL(){
        return localPosition;
    }

    public void Set(float x, float y, float z){
        this.globalPosition.Set(x, y, z);
    }
    

    public XYZ toSubSector(){
        XYZ sub = this.globalPosition.DivideRoundUni(Sector.blockSize);
        return sub.DivideR(SubSector.subCount);
    }

    /** Zmena lokalnych suradnic */
    public void toLocal(XYZ local){
//        XYZ multy = SubSector.subCount.MultyUni(Sector.blockSize);
//        XYZ basePt = local.Multy(multy);
        this.localPosition = globalPosition.Subtract(local);
    }

    private float Desatinka(float n){
        int x = Math.round(n*100);
        return (float)x/100;
    }

    public String printLocal(){
        return Desatinka(localPosition.x) + Main.spacer  + Desatinka(localPosition.y) + Main.spacer + Desatinka(localPosition.z);
    }

    /**
     * Vypis bodu do retazca
     * @return Point_String
     */
    @Override
    public String toString(){
        return globalPosition.x + Main.spacer  + globalPosition.y + Main.spacer + globalPosition.z;
    }

    @Override
    public int compareTo(Point ptN) {
        return (int) (this.Position().z - ptN.Position().z);
    }

}


