package robo_d;

import java.util.HashMap;
import java.util.List;

/**
 * Trida vypoctoveho typu.
 * Vytvorenie vlastneho bloku pre body v scene.
 * @author kurilluk
 */
public class Sector {

    //=STATIC===================================================================
    /** Rozmer bloku */
    static public float blockSize = blockSize();
    /** Sektor zoznam jeho blokov */
    static public HashMap<Object,Point> blocks = new HashMap(120092);

    /**Limity sektoru
     * naplnim ich pri pri nacitavani bodu
     */
    public static XYZ min = new XYZ(Integer.MAX_VALUE,Integer.MAX_VALUE,Integer.MAX_VALUE);
    public static XYZ max = new XYZ(Integer.MIN_VALUE,Integer.MIN_VALUE,Integer.MIN_VALUE);

    /**Actual index of nextPoint*/
     private static int a;
    //private static XYZ act;

    /* pole pre postupne nacitavanie bodov */
    private static Object[] keys;

    //=STATIC=METOD=============================================================

    /**
     * Vypocet velkosti bloku v sektore :
     * vypocet stran bloku ak plati uhlopriecka = priemer.
     * Plati: blok obsahuje vzdy len 1 bod
     * @return blockSize_float
     */
    private static float blockSize() {
        //return (float) (Math.sqrt(Math.pow(Main.diameter -0.2f, 2) / 3));
        return (float)((Main.diameter/Math.sqrt(3)));
        //return Main.diameter/10;
    }

    public static XYZ getMin(){
        return min;
    }

    public static XYZ getMax(){
        return max;
    }

    /**Vypocita min a max hodnotu suradnic blokov v sektore
     * aktualizujem, volam pri Sector.AddPoint;
     */
    //TODO vymysliet to nieako sikovnejsie :)
    private static void sectorLimit(XYZ block) {
        if (block.xi < min.xi) {
            min.xi = block.xi;
        }
        if (block.yi < min.yi) {
            min.yi = block.yi;
        }
        if (block.zi < min.zi) {
            min.zi = block.zi;
        }
        if (block.xi > max.xi) {
            max.xi = block.xi;
        }
        if (block.yi > max.yi) {
            max.yi = block.yi;
        }
        if (block.zi > max.zi) {
            max.zi = block.zi;
        }
    }

    /**Ak po presune bodu nastane zmena bloku, sektor bod z bloku vymaze
     * a doplni bod do noveho bloku.
     */
    public static boolean MovePoint(Point pt,XYZ moveTo) {

        String key = PointBlock(pt.Position()).toKey();
        XYZ indexNew = PointBlock(moveTo);
        String keyNew = indexNew.toKey();

         if(!key.equals(keyNew)){
            if (blocks.containsKey(keyNew)) {
            System.out.println("Err : Sector.MovePoint keyNew v bloku uz existuje");
            return false;
            }
            blocks.remove(key);           
            blocks.put(keyNew, pt);
            //pt.setBlock(indexNew);
            sectorLimit(indexNew);
        }
        return true;
    }

    public static void KillPoint(Point pt){
        KillPoint(pt,blocks);
    }

    /**Odstrani bod zo zoznamu */
    public static void KillPoint(Point pt,HashMap<Object,Point> map){
        String key = PointBlock(pt.Position()).toKey();
        map.remove(key);
        SectorInfo.killed ++;
    }


    /** Vypocita blok pre bod */
    public static XYZ PointBlock(XYZ position){
        return position.DivideRoundUni(blockSize);
    }

    public static void setLimit(List<Point>pts,boolean add){
        for(Point pt : pts){
             XYZ index = PointBlock(pt.Position());
             sectorLimit(index);
             if(add){
                 AddPoint(pt,index);
             }
        }

    }

    public static boolean AddPoint(Point pt){
        XYZ index = PointBlock(pt.Position());
        return AddPoint(pt, index);
    }

    public static boolean AddPoint(Point pt,XYZ index){
        return AddPoint(pt,index,blocks);
    }

    public static boolean AddPoint(Point pt,HashMap<Object,Point> map){
        XYZ index = PointBlock(pt.Position());
        return AddPoint(pt,index,map);
    }

    /** Prida bod pomocou jeho prislusneho bloku do mapy */
    public static boolean AddPoint(Point pt, XYZ index, HashMap<Object,Point> map){
       
        String key = index.toKey();

        if (!map.containsKey(key)) {
            //pt.setBlock(index);
            //Analyze.OkolieBodu(pt, true, true);
            //if (pt.getPrienikCount() == 0) {
                //sectorLimit(index);
                map.put(key, pt);
                //System.out.println("KEY : "+ key +" : PT : "+pt);
                //TODO doplnanie atributov bodu
                //System.out.println(pt.toString());
                //File.outDobry.WritePt(pt.toString());
                return true;
            //}else{
                //System.out.println("prienik");
            //}
        }
        SectorInfo.ErrPointAdd();
        //File.outZly.WritePt(pt.toString());

        //Main.Say("ERR: in point : "+ pt.toString() + " block " + key + " exist");
        System.out.println("ErrPoint : "+ SectorInfo.ErrPoints+"\n"
                + " PT1 : "+pt.toString()
                + " PT2 : "+map.get(key).toString());
        return false;

    }
    public static Object[] GetKeys(){
        return GetKeys(blocks);
    }
    /** Vrati pole key v sektore*/
    public static Object[] GetKeys(HashMap<Object,Point> map){
        return map.keySet().toArray();
    }

    public static Point GetPoint(Object key){
        return GetPoint(key,blocks);
    }

    /**Vrati bod zo sektoru*/
    public static Point GetPoint(Object key,HashMap<Object,Point> map){
        if(map.containsKey(key)){
            return (Point)map.get(key);
        } else {
            return null;
        }
    }
    /**resetuje aktualny bod a vytvara keys pole - slo by to aj prerobit */
    public static void SetActual(){
//        act = new XYZ(min.xi,min.yi,min.zi);
//        a = min.xi;
//        b = min.yi;
//        c = min.zi;
        //TODO zamysliet sa nad aktualizaciou
        keys = blocks.keySet().toArray();
        a = 0;
    }

    /* Metoda pre postupny vyber bodov v sektore (bez usporiadania) */
    public static Point GetNext() {
        if (a < keys.length) {
            for (int i = a; i < keys.length; i++) {
                a++;
                return (Point) blocks.get(keys[i]);
            }
        }
        a = 0;
        return null;
    }

    /**Vypise limitne bloky sekoru */
       public static String PrintSectorLimit() {
        return ("Limits : X : " + min.xi + "/" + max.xi + " : Y : " + min.yi + "/" + max.yi
                + " : Z : " + min.zi + "/" + max.zi);
    }

    /**Vymaze zoznamy o bodoch*/
    public static boolean Reset() {
        blocks.clear();
        SectorInfo.ErrPoints = 0;
        return SubSector.clear();
    }

    // none konstructor
    private Sector(){
        
    }

//    static private void vytvorRez(int z) {
//        XYZ index;
//        String key;
//        Point pt;
//
//        for (int y = min.yi; y <= max.yi; y++) {
//            for (int x = min.xi; x <= max.xi; x++) {
//                //System.out.println(x+":"+y+":"+z);
//                index = new XYZ(x, y, z);
//                key = index.toKey();
//                pt = GetPoint(key);
//                if (pt != null) {
//                    //pt.koren = true;
//                }
//            }
//        }
//    }

} //close class

