package robo_d;

import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Vector;
import java.util.Collections;
import java.util.Comparator;
import javax.sound.midi.SysexMessage;

/**
 *
 * @author kurilluk
 */
public class SubSector {

    /** Zoznam vytvorenych subSektorov */
    public static HashMap<Object,SubSector> subSectors = new HashMap(420);

    /** Pocet blokov v SubSektore */
    static public XYZ subCount = blockCount();

    /** Rozmer SubSektoru (v globalnych jednotkach) */
    static public XYZ subSectorSize = sectorSize();

//    /** Z-Limit subsektorov */
//    static private int[] zlimit = Limit.rezy.z;
//    static private int[] xlimit = Limit.rezy.x;

    //private static


    //=INSTANS==================================================================

    /** Lokalny pociatocny bod */
    public final XYZ local;
    
    public final XYZ index;

    /** Meno sektoru */
    private Object name;

    private List<Point> Pts;

    public boolean Reversed = false;

    private HashMap<Object,Point> mapa = new HashMap(1024);

//    /** Zoznam bodov v bloku sektora */
//    private HashMap map = new HashMap(4092);

    //==========================================================================
    /** Vypocet poctu blokov pre jeden SubSektor */
    private static XYZ blockCount() {
        int x, y, z;

//        x = (int) (Main.limitBlock.x / Sector.blockSize);
//        y = (int) (Main.limitBlock.y / Sector.blockSize);
//        z = (int) (Main.limitBlock.z / Sector.blockSize);

        x = 49;
        y = 25;
        z = 13;

        return new XYZ(x, y, z);
    }
    private static void reset(){
        subSectors.clear();
    }
    public static void CreateSubSectors(Collection<Point> pts){
        reset();
        for(Point pt : pts){
            XYZ sub = toSubSector(pt.Position());
            if(!subSectors.containsKey(sub.toKey())){
                SubSector subSec = new SubSector(sub,null);
                subSectors.put(subSec.name, subSec);
            }
        }
    }

   private static XYZ toSubSector(XYZ position){
        XYZ sub = position.DivideUni(Sector.blockSize);
        return sub.DivideR(SubSector.subCount);
    }

    public static void MakeSubsectors() {
        clear();
        XYZ name = new XYZ();

        int iMax = (Sector.max.zi - Sector.min.zi)/subCount.zi + 1;
        int jMax = (Sector.max.yi - Sector.min.yi)/subCount.yi + 1;
        int kMax = (Sector.max.xi - Sector.min.xi)/subCount.xi + 1;

        for (int i = 0; i < iMax; i++) {
            for (int j = 0; j < jMax; j++) {
                for (int k = 0; k < kMax; k++) {
                   name.Set(k, j, i);
                   List<Point> pts = AddPts(name);
                   if(pts.size() > 0){
                        SubSector sub = new SubSector(name,pts);
                        subSectors.put(sub.name,sub);
                        //System.out.println("SubSector : " +k+" : "+j+" : "+i);
                    }
                }
            }
        }
    }

    private static List<Point> AddPts(XYZ name) {
        XYZ key = new XYZ();
        ArrayList<Point> pts = new ArrayList();
        Point pt;

        for (int i = 0; i < subCount.zi; i++) {
            for (int j = 0; j < subCount.yi; j++) {
                for (int k = 0; k < subCount.xi; k++) {
                    key.Set(name.xi *subCount.xi + k, name.yi * subCount.yi + j, name.zi * subCount.zi + i);
                    pt = Sector.GetPoint(key.toKey());
                    if (pt != null) {
                        //System.out.println("SubSector POINT : " +key.toString());
                        pt.toLocal(name);
                        pts.add(pt);
                    }
                }
            }
        }
        return pts;
    }


     /** Vypocet globalnych rozmerov sektoru
     * @return XYZ_Global_Size
     */
    private static XYZ sectorSize() {
        float x, y, z;

        x = subCount.x * Sector.blockSize;
        y = subCount.y * Sector.blockSize;
        z = subCount.z * Sector.blockSize;

        //System.out.println("SubSector size : "+x+" : "+y+" : "+z);

        return new XYZ(x, y, z);
    }

//    /**vypocitam limitne pole blokov*/
//    private static int[] bLimit(float[] rezy){
//        int count = rezy.length;
//        int[] pole = new int[count];
//      for(int i = 0; i <count;i++){
//        pole[i] = Math.round(rezy[i]/Sector.blockSize);
//      }
//      return pole;
//    }

//    public static void ReadBlocks() {
//        //for each cuts
//        int xCut,yCut,zCut;
//        HashMap blok;
//        int count = 0;
//
//        for (int i = 0; i < Limit.CutsCount.z*0+1 ; i++) {
//            for (int j = 0; j < Limit.CutsCount.x*0+1 ; j++) {
//                for (int k = 0; k < Limit.CutsCount.y*0+1 ; k++) {
//
//                   zCut = Limit.rezy.z[i];
//                   xCut = Limit.rezy.x[j];
//                   yCut = Limit.rezy.y[k];
//
//                    //vytvorim objekt to hash tabulky ktory naplnim dalsou hash tab.?
//                   blok =  naplnSubSector(xCut, yCut, zCut);
//                   if(blok != null){
//                       XYZ index = new XYZ(j,k,i);
//                       subSectors.put(index.toKey(),blok);
//                       count ++;
//                       System.out.println(count +" : "+ index.toKey()+" : "+blok.size());
//                   }
//
//                }
//            }
//        }
//        System.out.println("Subsector.ReadBlocks : OK");
//    }

    private static HashMap naplnSubSector(int xCut, int yCut, int zCut) {
        XYZ i = new XYZ();
        Point pt;
        boolean pts = false;
        HashMap points = new HashMap(4092);

        for (int z = 0; z < Limit.blocksInCut.zi; z++) {
            for (int x = 0; x < Limit.blocksInCut.xi; x++) {
                for (int y = 0; y < Limit.blocksInCut.yi; y++) {

                    i.xi = xCut + x;
                    i.yi = yCut + y;
                    i.zi = zCut + z;

                    pt = Sector.GetPoint(i.toKey());
                    if (pt != null) {
                        //TODO get local
                        points.put(new XYZ(x, y, z).toKey(), pt);
                        pts = true;
                    }

                }
            }
        }
        if (pts) {
            return points;
        } else {
            return null;
        }
    }

    public static Vector<String> ListSubSectors(){
       return new Vector(subSectors.keySet());
    }

        public static List<Point> SortPts(List<Point> PtsS){
        Comparator y = new podlaY();
        Comparator x = new podlaX();
        Collections.sort(PtsS,x);
        Collections.sort(PtsS,y);
        Collections.sort(PtsS);
        return PtsS;
    }

//  ============================================================================

    
    public static boolean clear(){
        subSectors.clear();
        return subSectors.isEmpty();
    }

     //=INSTANS=METOD===========================================================
    /** Skryty konstrukor sektoru */
    private SubSector(XYZ i,List<Point> pts) {
        // ?? this.local = index.Multy(subSectorSize);
        this.index = new XYZ(i.xi,i.yi,i.zi);
        this.name = index.toKey();
        this.Pts = pts;
        this.local = SubtoLocal(index);
    }

    private XYZ SubtoLocal(XYZ index){
         XYZ multy = SubSector.subCount.MultyUni(Sector.blockSize);
        return index.Multy(multy);
    }

    public int PtsSize(){
        return Pts.size();
    }

    public List<Point> GetPts(){
        return this.Pts;
    }

    public void SetPts(List<Point> points){
        Pts = points;
        SortPts();
    }

    public void ResetPts(){
        Pts = null;
    }

    public void SortPts(){
        Pts = SortPts(this.Pts);
    }
    
    private XYZ midPoint(){
        int yi = (int) SubSector.subCount.yi /2;
        int zi = (int) SubSector.subCount.zi /2;
        float y = this.local.y + (yi* Sector.blockSize);
        float z = this.local.z + (zi * Sector.blockSize);
        XYZ mid =  new XYZ(0,y,z);
        //System.out.println("MID POINT :"+ mid.toString());
        return mid;
    }

    private List<Point> reversePts(){
        List<Point> pts = new ArrayList<Point>(Pts.size());
        XYZ mid = midPoint();
        for(Point pt : Pts){
            XYZ pos = pt.Position();
            if(mid.y <= pos.y && mid.z <= pos.z){
                pos.y = mid.y + (mid.y - pos.y);
                pos.z = mid.z + (mid.z - pos.z);
            }else if(mid.y >= pos.y && mid.z <= pos.z){
                pos.y = mid.y - (-mid.y + pos.y);
                pos.z = mid.z + (mid.z - pos.z);
            }else if(mid.y <= pos.y && mid.z >= pos.z){
                pos.y = mid.y + (mid.y - pos.y);
                pos.z = mid.z - (-mid.z + pos.z);
            }else if(mid.y >= pos.y && mid.z >= pos.z){
                pos.y = mid.y - (-mid.y + pos.y);
                pos.z = mid.z - (-mid.z + pos.z);
            }
            pts.add(new Point(pos));
        }
        return SortPts(pts);
    }

    public HashMap<Object,Point> VytvorMapu(Boolean rev){
        Reversed =rev;
        if(rev){
            return VytvorMapu(reversePts());
        }else{
            return VytvorMapu(this.Pts);
        }
    }

    private HashMap<Object,Point> VytvorMapu(List<Point> pts){
        HashMap<Object,Point> map = new HashMap(4092);

        for(Point pt : pts){
            Sector.AddPoint(pt,map);
        }
        mapa = map;
        return map;
    }

    public HashMap<Object,Point> GetMap(){
        return mapa;
    }

//    public void printAllPoints() {
//        for (Object p : this.points.values()) {
//            Point pt = (Point) p;
//
//            System.out.println(pt.toString());
//            //pt.VectorsPrint();
//        }
//    }

    /** Vypis nazvu sektora */
    @Override
    public String toString() {
        return this.name.toString();
    }

        public String toFile() {
        return "x"+index.xi+"y"+index.yi+"z"+index.zi;
    }



} //close class