package robo_d;

import javax.vecmath.Vector3f;


/**
 * Prievoznik (prepravka) pre suradnice XYZ a aj indexovanie
 * @author kurilluk
 */
public class XYZ {

    public float x, y, z;
    public int xi, yi, zi;

    public XYZ() {
        this(0, 0, 0);
    }
    
    public XYZ(int x, int y, int z) {
        this.xi = x;
        this.yi = y;
        this.zi = z;
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public XYZ(float x, float y, float z) {
        this.x = x;
        this.y = y;
        this.z = z;
        this.xi = (int) x;
        this.yi = (int) y;
        this.zi = (int) z;
    }

    public XYZ(XYZ a){
        this(a.x,a.y,a.z);
    }

    //je to koli ToKey.. okolie
    public void Set(int x,int y, int z){
        this.xi = x;
        this.yi = y;
        this.zi = z;
        this.x = x;
        this.y = y;
        this.z = z;
    }

    public void Set(float x, float y, float z){
        this.x = x;
        this.y = y;
        this.z = z;
        this.xi = (int) x;
        this.yi = (int) y;
        this.zi = (int) z;
    }

    public XYZ SubtractRound(XYZ minus) {
        int xr, yr, zr;
        xr = (this.xi - minus.xi);
        yr = (this.yi - minus.yi);
        zr = (this.zi - minus.zi);
        return new XYZ(xr, yr, zr);
    }

       public XYZ SubtractUni(int minus) {
        float xm, ym, zm;
        xm = this.x - minus;
        ym = this.y - minus;
        zm = this.z - minus;
        return new XYZ(xm, ym, zm);
    }

       public boolean isSmaller(XYZ p){
           if(this.x < p.x || this.y < p.y || this.z < p.z){
               return true;
           }else{
               return false;
           }
       }

    public XYZ Subtract(XYZ minus) {
        float xm, ym, zm;
        xm = this.x - minus.x;
        ym = this.y - minus.y;
        zm = this.z - minus.z;
        return new XYZ(xm, ym, zm);
    }

        public XYZ DivideR(XYZ div) {
        float xr, yr, zr;
        xr = (this.x / div.x);
        if(xr<0){xr= xr-1;}
        yr = (this.y / div.y);
        if(xr<0){yr= yr-1;}
        zr = (this.z / div.z);
        if(xr<0){zr= zr-1;}
        return new XYZ(xr, yr, zr);
    }

    public XYZ DivideRound(XYZ div) {
        int xr, yr, zr;
        xr = (this.xi / div.xi);
        yr = (this.yi / div.yi);
        zr = (this.zi / div.zi);
        return new XYZ(xr, yr, zr);
    }

    public XYZ DivideRoundUni(float div) {
        int xr, yr, zr;
        xr = Math.round(this.x / div);
        yr = Math.round(this.y / div);
        zr = Math.round(this.z / div);
        return new XYZ(xr, yr, zr);
    }

    public XYZ DivideUni(float div) {
        float xr, yr, zr;
        xr = (this.x / div);
        yr = (this.y / div);
        zr = (this.z / div);
        return new XYZ(xr, yr, zr);
    }

       public XYZ MultyInt(XYZ multy) {
        int xx, yx, zx;
        xx = this.xi * multy.xi;
        yx = this.yi * multy.yi;
        zx = this.zi * multy.zi;
        return new XYZ(xx, yx, zx);
    }

    public XYZ Multy(XYZ multy) {
        float xx, yx, zx;
        xx = this.x * multy.x;
        yx = this.y * multy.y;
        zx = this.z * multy.z;
        return new XYZ(xx, yx, zx);
    }

    public XYZ Add(XYZ add) {
        float xx, yx, zx;
        xx = this.x + add.x;
        yx = this.y + add.y;
        zx = this.z + add.z;
        return new XYZ(xx, yx, zx);
    }

    public XYZ MultyUni(float multy) {
        float xx, yx, zx;
        xx = this.x * multy;
        yx = this.y * multy;
        zx = this.z * multy;
        return new XYZ(xx, yx, zx);
    }

    public Vector3f VectorFrom2Pt(XYZ ptN){
            XYZ v = ptN.Subtract(this);
            //v = v.DivideUni(2f);
           return new Vector3f(v.x, v.y, v.z);
    }

    public Vector3f VectorFrom2PtScale(XYZ ptN,float scale){
            Vector3f vec = VectorFrom2Pt(ptN);
            System.out.println(vec.length());
            vec.normalize();
            vec.scale(scale);
            return vec;
    }

    //TODO chyba prepisujem si tu aj vektor!!!
    public XYZ move(Vector3f vec){
        Vector3f tmp = new Vector3f(vec);
        tmp.add(new Vector3f(this.x,this.y,this.z));
        return new XYZ(tmp.x,tmp.y,tmp.z);
    }

    public String toKey() {
        //return (int) x + ((int) y << 16) + ( (int) z << 32);
        return this.xi + Main.spacer + this.yi + Main.spacer + this.zi;
    }

    /**
     * Vypis suradnic do retazca
     * @return XYZ_String
     */
    @Override
    public String toString() {
        return this.x + Main.spacer + this.y + Main.spacer + this.z;
    }
}
